;****************************************************************************
;*
;*	opcode help - created 1997 by future vision
;*	example for using the external debugger handler
;*
;*	tasm compatible source code
;*
;****************************************************************************

.386

closed_pos	EQU (15*80+80-16)*2

main_seg		SEGMENT	USE16
	ASSUME	CS:main_seg
	ASSUME	DS:main_seg
	ORG	100h

com_entry:	jmp	start_up
	ORG	103h
		DB	'UILM'			;sign
		DW	offset low_mem_end-100h	;low memory size
		DD	0			;no xms
		DD	0
		DW	111101111111b		;load, unload, external hk
;			  ^8  ^4  ^0
		DB	0			;no def internal hotkey
		DW	0			;no def external hotkey
		DW	0
		DB	'Opcode help',0		;name
		DB	'OPHL'			;id
;****************************************************************************
start_up		PROC	NEAR
		push		si
		push		ds
		mov		ah,0
		int		32h
		pop		es
		pop		si
		push		cs
		pop		ds
		cmp		ax,'IS'
		jne	dos_call
		test		cl,100b		;uilm execution
		jz	dos_call
		shr		cl,3
		and		cl,111b
		cmp		cl,101b		;termin call before unloading
		je	uninstall
		cmp		cl,100b		;start up call after loaded
		je	install

		mov		ah,02h		;hotkey call
		int		32h
		mov		si,offset $index
		call	setup_opcode
		mov		win_lines,38
		mov		window_pos,10*160
		push		word ptr status
		mov		status,2
		call	far ptr handler_entry
		pop		word ptr status
		mov		al,21h
		retf
start_up		ENDP


handler			PROC	FAR
	LOCALS
	;>bl  current line number in debugger
		push		cs		;load data segment
		pop		ds
		cmp		al,1
		jne	@@no_remove
;remove an older handler
		cmp		[old_handler],ebx
		jne	@@jump
		mov		[old_handler],ecx
		retf
@@jump:		jmp	dword ptr [old_handler]
;****************************************************************************
;external debugger handler		
@@no_remove:	cmp		status,0	;0=closed look (minimized)
		jne	@@usual_look
;closed look
		cmp		[old_handler],0	;no more handler
		jne	@@old_handler
		mov		ax,-1
		call	disassemble		;disassemble all
		mov		si,offset $closed_look
		mov		di,closed_pos
		call	write_string		;write minimized information
@@key_ret:	mov		ah,0
		int		16h		;return scan code
		jmp	@@write_closed
@@old_handler:	call	dword ptr [old_handler]
@@write_closed:	cmp		status,0	;not closed look
		jne	@@check_hotkey
		mov		si,offset $closed_look
		mov		di,closed_pos
		call	write_string
@@check_hotkey:	cmp		al,'1'		;pop up hotkey?
		jne	@@not_hotkey
		mov		status,2	;enable
@@not_hotkey:	retf
;****************************************************************************
;the usual way to display information - common code
@@usual_look:	mov		cx,12*160	;set the window position
		mov		ax,2313h
		cmp		bl,11h	;bl=line in debugger
		ja	@@upper_position
		mov		ax,1100h
		mov		cx,30*160
@@upper_position:
		mov		window_pos,cx
		mov		win_lines,15
		call	disassemble		;disassemble
	;>esi	address at current line
	;>bl	current line number
		
		mov		ah,07		;get mnemonic of addr in esi
		int		32h
		push		es
		pop		ds
		add		si,20h
		call	setup_opcode

		cmp		status,2
		je	@@enabled_win
;***************
;inactive window
		mov		window_offs,offset win1_data
		mov		si,offset $help_line_
		call	setup_data		;draw window, open file
		jc	@@key_ret

		call	find_start		;search until found or key
		jc	@@close_end
		jz	@@found_i
@@find_loop_i:	mov		ah,1	;key?
		int		16h
		jnz	@@close_end
		call	find_help
		jc	@@close_end
		jnz	@@find_loop_i
@@found_i:	call	write_data		;write data
@@close_end:	mov		ah,3eh		;close file, read key, return
		int		21h
		jmp	@@key_ret
;***************
;activated window
@@enabled_win:	
handler_entry:	mov		window_offs,offset win2_data
		mov		si,offset $help_line
		call	setup_data		;draw window, open file
		jc	@@key_ret
@@search:	xor		cx,cx		;search until found
		mov		dx,cx
		mov		ax,4200h
		int		21h
		mov		si,offset $help_line
		call	show_win
		call	find_start
		jc	@@close_end
		jz	@@found_a
@@find_loop_a:	call	find_help
		jc	@@close_end
		jnz	@@find_loop_a
@@found_a:
@@draw_loop:	call	write_data		;write data
;****************************************************************************
;keybord stuff and actions
@@input_loop:	mov		ah,0
		int		16h
		cmp		al,'s'
		jne	@@no_search
		mov		ah,27h		;get search string
		mov		si,offset search_buffer
		int		32h
		jc	@@input_loop
		mov		di,si
@@search_setup:	push		di
		mov		si,offset opcode_data
		movzx		ax,link_pointer	;update link buffer
		inc		al
		and		al,7h
		mov		link_pointer,al
		imul		di,ax,size link_buf_struc
		add		di,offset link_buf
		movsd
		movsd
		mov		al,first_line
		stosb
		mov		ax,link_cur
		stosw
		pop		si
		call	setup_opcode		;init data and continue
		jmp	@@search
@@no_search:	cmp		al,8
		jne	@@no_back_link
		mov		di,offset opcode_data
		push		di
		movzx		ax,link_pointer
		imul		si,ax,size link_buf_struc
		dec		al
		and		al,7
		mov		link_pointer,al
		add		si,offset link_buf
		movsd
		movsd
		lodsb
		mov		first_line,al
		lodsw
		mov		link_cur,ax
		pop		si
		call	setup_opcode_ex
		jmp	@@search
@@no_back_link:	cmp		al,'h'		;help
		jne	@@no_help
		mov		di,offset search_buffer
		mov		[di],'PLEH'
		mov		byte ptr [di+4],0
		jmp	@@search_setup
@@no_help:	cmp		al,'i'		;index
		jne	@@no_index
		mov		di,offset search_buffer
		mov		[di],'EDNI'
		mov		dword ptr [di+4],'X'
		jmp	@@search_setup
@@no_index:	cmp		ah,73		;pgu
		jne	@@no_pgu
		cmp		link_cur,0
		je	@@input_loop
		dec		link_cur
		jmp	@@draw_loop
@@no_pgu:	cmp		ah,81		;pgd
		jne	@@no_pgd
		mov		ax,link_count
		dec		ax
		cmp		ax,link_cur
		je	@@input_loop
		inc		link_cur
		jmp	@@draw_loop
@@no_pgd:	cmp		al,13		;cr
		jne	@@no_cr
		mov		di,offset link_data
		cmp		link_offset,di
		je	@@input_loop
		jmp	@@search_setup
@@no_cr:
		cmp		ah,72		;up
		jne	@@no_up
		dec		first_line
		jns	@@draw_loop
		inc		first_line
@@no_up:	cmp		ah,80		;down
		jne	@@no_down
		mov		ah,line_count
		mov		cl,win_lines
		dec		cl
		cmp		ah,cl
		jbe	@@input_loop
		inc		first_line
		jmp	@@draw_loop
@@no_down:	cmp		al,'z'
		jne	@@no_zoom
		cmp		win_lines,30
		ja	@@input_loop
		mov		first_line,0
		mov		win_lines,35
		mov		window_pos,10*160
		mov		skip_line,1234h
		mov		si,offset $help_line
		call	show_win
		jmp	@@draw_loop
@@no_zoom:	cmp		al,'m'		;minimize
		jne	@@no_min
		mov		status,0
		jmp	@@end_return
@@no_min:	cmp		al,27		;esc
		jne	@@input_loop
		mov		status,1
@@end_return:	mov		ah,3eh
		int		21h
		xor		ax,ax	;return no scan code
		retf
handler			ENDP
;****************************************************************************
setup_opcode		PROC	NEAR
;init search string
	LOCALS
		mov		cs:first_line,0
		mov		cs:link_cur,0
setup_opcode_ex:push		cs
		pop		es
		mov		di,offset opcode_data
		mov		cx,8
@@move_opc:	lodsb
		cmp		al,'a'
		jb	@@dont_upcase
		sub		al,'a'-'A'
@@dont_upcase:	cmp		al,20h
		jbe	@@store_zerro
		stosb
		loop	@@move_opc
@@return:	push		cs
		pop		ds
		ret
@@store_zerro:	xor		al,al
		rep stosb
		jmp	@@return
setup_opcode		ENDP

find_start		PROC	NEAR
;restart search operation
		mov		find_prec,0
		mov		ax,topics	;setup start pos
		mov		right,ax
		mov		left,0
		shr		ax,1
		mov		current,ax
find_start		ENDP
;search proc - a kind of binary search
find_help		PROC	NEAR
	LOCALS
		movzx		eax,current	;calc file pos
		imul		eax,8+4+1
		add		eax,2
		push		eax
		pop		dx
		pop		cx
		mov		ax,4200h	;seek
		int		21h
		mov		cx,8+4+1	;and load
		mov		dx,offset buffer
		mov		ah,3fh
		int		21h
		jc	@@error
		mov		di,offset opcode_data
		mov		si,offset buffer
		mov		cx,8
		repe cmpsb
		ja	@@go_left
		je	@@found
@@go_right:	mov		dx,current
		mov		left,dx
		mov		ax,right
		sub		ax,dx
		je	@@found
		shr		ax,1
		jnz	@@right_delta
		inc		ax
		cmp		cl,find_prec
		jbe	@@found
		mov		find_prec,cl
@@right_delta:	add		current,ax
@@not_found:	inc		ax
		clc
		ret
@@go_left:	mov		ax,current
		mov		right,ax
		mov		dx,left
		sub		ax,dx
		je	@@found
		shr		ax,1
		jnz	@@left_delta
		inc		ax
		cmp		cl,find_prec
		jbe	@@found
		mov		find_prec,cl
@@left_delta:	sub		current,ax
		jmp	@@not_found
@@found:	mov		eax,dword ptr buffer+8
		mov		file_pos,eax
		mov		al,buffer+8+4
		mov		lines,al
		xor		al,al
		clc
		ret
@@error:	stc
		ret
find_help		ENDP

setup_data		PROC	NEAR
;open file and read number of topics
	LOCALS
		call	show_win
		mov		dx,offset file_name
		mov		ax,3d00h
		int		21h
		mov		bx,ax
		jc	@@return_now
		mov		dx,offset topics
		mov		cx,2
		mov		ah,3fh
		int		21h
@@return_now:	ret
setup_data		ENDP

write_data		PROC	NEAR
;write found data into window
	LOCALS
		mov		ax,4200h			;seek to text
		mov		dx,word ptr [file_pos]
		mov		cx,word ptr [file_pos+2]
		int		21h
		mov		al,lines
		mov		text_lines,al
		mov		al,first_line
		mov		show_line,al
		mov		line_count,0			;set defaults
		mov		link_count,0
		mov		link_count,0
		mov		link_offset,offset link_data
		xor		si,si
		mov		di,window_pos
		add		di,162
		push		di
		mov		al,' '				;clear line
		call	write_line
		pop		di
		cmp		first_line,0
		je	@@read_loop
		push		di				;scroll up
		add		di,160-6
		mov		al,30
		call	write_char
		pop		di

@@read_loop:	push		ds
		push		si
		lds		dx,buffer_pos
		xor		ah,ah
		and		si,1ffh
		jnz	@@dont_load
		mov		ah,3fh
		mov		cx,200h
		int		21h
		lahf
@@dont_load:	add		si,dx
		lodsb
		pop		si
		pop		ds
		inc		si
		
		or		al,al
		jne	@@old_line
		mov		color,30h
		dec		text_lines
		jz	@@read_error
		dec		show_line
		jns	@@next_char
		mov		cx,160
		mov		ax,di
		xor		dx,dx
		div		cx
		inc		ax
		mul		cx
		mov		di,ax
		add		di,2
		inc		line_count
		mov		cl,win_lines
		dec		cl
		cmp		line_count,cl
		ja	@@no_link_end
		push		di
		mov		al,' '
		call	write_line
		pop		di
		jmp	@@next_char
@@old_line:
		cmp		al,3
		jne	@@no_hgl
		mov		color,31h
		jmp	@@next_char
@@no_hgl:	cmp		al,1
		jne	@@no_link
		mov		color,3eh
		mov		ax,link_count
		cmp		ax,link_cur
		jne	@@not_cur_link
		mov		color,1eh
@@not_cur_link:	inc		link_count
		jmp	@@next_char
@@no_link:	cmp		al,2
		jne	@@no_link_end
		mov		color,30h
		jmp	@@next_char
@@no_link_end:	mov		ah,line_count
		mov		cl,win_lines
		dec		cl
		cmp		ah,cl
		jbe	@@line_ok
		sub		di,6
		mov		al,31
		jmp	write_char
@@line_ok:	cmp		show_line,0
		jg	@@next_char
		cmp		color,1eh
		jne	@@no_link_dat
		push		di
		mov		di,link_offset
		stosb
		mov		byte ptr [di],0
		mov		link_offset,di
		pop		di
@@no_link_dat:	cmp		al,9
		jne	@@no_tab
		mov		cx,10h
		mov		ax,di
		xor		dx,dx
		div		cx
		inc		ax
		mul		cx
		mov		di,ax
		jmp	@@next_char
@@no_tab:


		call	write_char
@@next_char:	jmp	@@read_loop
@@read_error:	ret
write_data		ENDP

show_win		PROC	NEAR
;draws window
	LOCALS
		push		si
		mov		si,window_offs
		mov		di,window_pos
		mov		color,3fh
		mov		al,[si]		;''
		call	write_char
		mov		al,[si+1]	;''
		call	write_line
		mov		al,[si+2]	;''
		call	write_char
		movzx		cx,win_lines
@@win_loop:	mov		al,[si+3]	;''
		call	write_char
		mov		color,30h
		mov		al,' '
		call	write_line
		mov		color,3fh
		mov		al,[si+3]	;''
		call	write_char
		loop	@@win_loop
		mov		al,[si+4]	;''
		call	write_char
		mov		al,[si+1]	;''
		call	write_line
		mov		al,[si+5]	;''
		call	write_char
		sub		di,(80-2)*2
		pop		si
		call	write_string
		mov		color,30h
		mov		di,window_pos
		add		di,162
		ret
show_win		ENDP
write_char		PROC	NEAR
		push		ax
		push		es
		mov		ah,color
		push		0b800h
		pop		es
		stosw
		pop		es
		pop		ax
		ret
write_char		ENDP
write_line		PROC	NEAR
	LOCALS
		push		cx
		mov		cx,78
@@line_loop:	call	write_char
		loop	@@line_loop
		pop		cx
		ret
write_line		ENDP
write_string		PROC	NEAR
	LOCALS
		push		ax
@@loop_string:	lodsb
		or		al,al
		jz	@@end_string
		call	write_char
		jmp	@@loop_string
@@end_string:	pop		ax
		ret
write_string		ENDP
;****************************************************************************
;data stuff
file_name	DB	80 DUP(0)

skip_line	DW	1234h

topics		DW	?
left		DW	?
right		DW	?
current		DW	?
win_lines	DB	15
buffer		DB	8+4+1 DUP(?)
opcode_data	DB	8 DUP(0)
lines		DB	?
file_pos	DD	?
line_count	DB	?

find_prec	DB	0
text_lines	DB	0
first_line	DB	?

window_pos	DW	?
window_offs	DW	?
win1_data	DB	'Ŀ'
win2_data	DB	'ͻȼ'
color		DB	30h
link_count	DW	0
link_offset	DW	0
link_cur	DW	0

link_buf_struc		STRUC
lbs_link	DB	'HELP    '
lbs_fline	DB	0
lbs_clink	DW	0
link_buf_struc		ENDS

link_pointer	DB	0
link_buf	link_buf_struc	<>
		link_buf_struc	<>
		link_buf_struc	<>
		link_buf_struc	<>

		link_buf_struc	<>
		link_buf_struc	<>
		link_buf_struc	<>
		link_buf_struc	<>

search_buffer	DB	30h DUP(?)
link_data	DB	8 DUP(0)
link_start	DB	0
show_line	DB	?
$closed_look	DB	' [1] opcode help',0
$help_line	DB	' ESC-Return H-Help I-'
$index		DB	'Index M-Minimize S-Search Z-Zoom ',0
$help_line_	DB	' [1]-Activate Window ',0
status		DB	1
buffer_pos	DD	?

this_handler	DD	?	;seg:offs of this handler
old_handler	DD	?	;seg:offs of previous handler
;****************************************************************************
disassemble		PROC	NEAR
;disassemble code skipping lines between al and ah
;return	esi	lin addr of cur line
;	bl	cur line number in debugger
	LOCALS
		cmp		ax,[skip_line]
		setne		cl			;1 if different lines
		mov		[skip_line],ax
@@dont_clear:	mov		bx,ax
		mov		ax,1502h		;disassemble
		int		32h
		ret
disassemble		ENDP
uninstall		PROC	NEAR
		mov		ebx,[this_handler]	;remove handler
		mov		ecx,[old_handler]
		mov		ax,1501h
		int		32h
		xor		al,al
		retf
uninstall		ENDP
install			PROC	NEAR
	LOCALS
		mov		si,es:[si+0ch]		;save buffer addr
		mov		word ptr [buffer_pos],si
		mov		word ptr [buffer_pos+2],es

		mov		ebx,'LHPO'		;get data file name
		mov		edx,'ELIF'
		mov		ah,18h
		int		32h
		jnc	@@continue
		mov		ax,2df2h		;undef uilm data
		int		32h
		mov		al,80h			;ret and unload
		retf
@@continue:	push		es			;copy data file name
		pop		ds
		push		cs
		pop		es
		mov		di,offset file_name
@@copy_fname:	lodsb
		stosb
		or		al,al
		jnz	@@copy_fname

		push		cs
		pop		ds

		push		cs			;calc handler address
		push		offset handler
		pop		ebx
		mov		[this_handler],ebx
		mov		ax,1500h		;add to chain
		int		32h
		mov		[old_handler],ebx	;save prev handler

		xor		al,al
		retf
install			ENDP
low_mem_end		LABEL	WORD

dos_call		PROC	NEAR
		mov		dx,offset $no_dos
		mov		ah,9h
		int		21h
		mov		ax,4c00h
		int		21h
dos_call		ENDP
$no_dos		DB	'Opcode help by FUTURE VISION - UILM id: OPHL',13,10
		DB	'...this is an user interface loadable module and can '
		DB	'not be executed by dos',13,10,'$'
main_seg		ENDS
			END	com_entry
